: Class Texture

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.media.j3d
Class Texture

    java.lang.Object
      |
      +--javax.media.j3d.SceneGraphObject
            |
            +--javax.media.j3d.NodeComponent
                  |
                  +--javax.media.j3d.Texture

Direct Known Subclasses:
  Texture2D, Texture3D

public abstract class Texture
extends NodeComponent

The Texture object is a component object of an Appearance object that defines the texture properties used when texture mapping is enabled. Texture object is an abstract class and all texture objects must be created as either a Texture2D object or a Texture3D object.

Field Summary
`static int` | `ALLOW_BOUNDARY_COLOR_READ` Specifies that this Texture object allows reading its boundary color information.
`static int` | `ALLOW_BOUNDARY_MODE_READ` Specifies that this Texture object allows reading its boundary mode information.
`static int` | `ALLOW_ENABLE_READ` Specifies that this Texture object allows reading its enable flag.
`static int` | `ALLOW_ENABLE_WRITE` Specifies that this Texture object allows writing its enable flag.
`static int` | `ALLOW_FILTER_READ` Specifies that this Texture object allows reading its filter information.
`static int` | `ALLOW_IMAGE_READ` Specifies that this Texture object allows reading its image component information.
`static int` | `ALLOW_MIPMAP_MODE_READ` Specifies that this Texture object allows reading its mipmap mode information.
`static int` | `ALPHA` Specifies Texture contains only Alpha values.
`static int` | `BASE_LEVEL` Indicates that Texture object only has one level.
`static int` | `BASE_LEVEL_LINEAR` Performs bilinear interpolation on the four nearest texels in level 0 texture map.
`static int` | `BASE_LEVEL_POINT` Select the nearest texel in level 0 texture map.
`static int` | `CLAMP` Clamps texture coordinates to be in the range [0, 1].
`static int` | `FASTEST` Uses the fastest available method for processing geometry.
`static int` | `INTENSITY` Specifies Texture contains only Intensity values.
`static int` | `LUMINANCE` Specifies Texture contains only luminance values.
`static int` | `LUMINANCE_ALPHA` Specifies Texture contains Luminance and Alpha values.
`static int` | `MULTI_LEVEL_LINEAR` Performs tri-linear interpolation of texels between four texels each from two nearest mipmap levels.
`static int` | `MULTI_LEVEL_MIPMAP` Indicates that this Texture object has multiple images- one for each mipmap level(i.e.
`static int` | `MULTI_LEVEL_POINT` Selects the nearest texel in the nearest mipmap.
`static int` | `NICEST` Uses the nicest available method for processing geometry.
`static int` | `RGB` Specifies Texture contains Red, Green and Blue color values.
`static int` | `RGBA` Specifies Texture contains Red, Green, Blue color values and Alpha value.
`static int` | `WRAP` Repeats the texture by wrapping texture coordinates that are outside the range [0,1].

Constructor Summary
`Texture()` Constructs a Texture object with default parameters.
`Texture(int mipmapMode, int format, int width, int height)` Constructs an empty Texture object with specified mipmapMode format, width and height.

Method Summary
`void` | `getBoundaryColor(Color4f boundaryColor)` Retrieves the texture boundary color for this texture object.
`int` | `getBoundaryModeS()` Retrieves the boundary mode for the S coordinate.
`int` | `getBoundaryModeT()` Retrieves the boundary mode for the T coordinate.
`boolean` | `getEnable()` Retrieves the state of the texture enable flag.
`ImageComponent` | `getImage(int level)` Gets a specified mipmap level.
`int` | `getMagFilter()` Retrieves the magnification filter.
`int` | `getMinFilter()` Retrieves the minification filter.
`int` | `getMipMapMode()` Retrieves current mipmap mode.
`void` | `setBoundaryColor(Color4f boundaryColor)` Sets the texture boundary color for this texture object.
`void` | `setBoundaryColor(float r, float g, float b, float a)` Sets the texture boundary color for this texture object.
`void` | `setBoundaryModeS(int boundaryModeS)` Sets the boundary mode for the S coordinate in this texture object.
`void` | `setBoundaryModeT(int boundaryModeT)` Sets the boundary mode for the T coordinate in this texture object.
`void` | `setEnable(boolean state)` Enables or disables texture mapping for this appearance component object.
`void` | `setImage(int level, ImageComponent image)` Sets a specified mipmap level.
`void` | `setMagFilter(int magFilter)` Sets the magnification filter function.
`void` | `setMinFilter(int minFilter)` Sets the minification filter function.
`void` | `setMipMapMode(int mipmapMode)` Sets mipmap mode for texture mapping for this texture object.

Methods inherited from class javax.media.j3d.NodeComponent
`cloneNodeComponent, duplicateNodeComponent, getDuplicateOnCloneTree, setDuplicateOnCloneTree`

Methods inherited from class javax.media.j3d.SceneGraphObject
`clearCapability, duplicateSceneGraphObject, getCapability, getUserData, isCompiled, isLive, setCapability, setUserData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ALLOW_ENABLE_READ

    public static final int ALLOW_ENABLE_READ

  Specifies that this Texture object allows reading its enable flag.

### ALLOW_ENABLE_WRITE

    public static final int ALLOW_ENABLE_WRITE

  Specifies that this Texture object allows writing its enable flag.

### ALLOW_BOUNDARY_MODE_READ

    public static final int ALLOW_BOUNDARY_MODE_READ

  Specifies that this Texture object allows reading its boundary mode information.

### ALLOW_FILTER_READ

    public static final int ALLOW_FILTER_READ

  Specifies that this Texture object allows reading its filter information.

### ALLOW_IMAGE_READ

    public static final int ALLOW_IMAGE_READ

  Specifies that this Texture object allows reading its image component information.

### ALLOW_MIPMAP_MODE_READ

    public static final int ALLOW_MIPMAP_MODE_READ

  Specifies that this Texture object allows reading its mipmap mode information.

### ALLOW_BOUNDARY_COLOR_READ

    public static final int ALLOW_BOUNDARY_COLOR_READ

  Specifies that this Texture object allows reading its boundary color information.

### FASTEST

    public static final int FASTEST

  Uses the fastest available method for processing geometry. This value can be used as a parameter to setMinFilter and setMagFilter.

### NICEST

    public static final int NICEST

  Uses the nicest available method for processing geometry. This value can be used as a parameter to setMinFilter and setMagFilter.

### BASE_LEVEL_POINT

    public static final int BASE_LEVEL_POINT

  Select the nearest texel in level 0 texture map. Maps to NEAREST

### BASE_LEVEL_LINEAR

    public static final int BASE_LEVEL_LINEAR

  Performs bilinear interpolation on the four nearest texels in level 0 texture map. Maps to LINEAR.

### MULTI_LEVEL_POINT

    public static final int MULTI_LEVEL_POINT

  Selects the nearest texel in the nearest mipmap. Maps to NEAREST_MIPMAP_NEAREST.

### MULTI_LEVEL_LINEAR

    public static final int MULTI_LEVEL_LINEAR

  Performs tri-linear interpolation of texels between four texels each from two nearest mipmap levels. Maps to LINEAR_MIPMAP_LINEAR, but an implementation can fall back to LINEAR_MIPMAP_NEAREST or NEAREST_MIPMAP_LINEAR.

### CLAMP

    public static final int CLAMP

  Clamps texture coordinates to be in the range [0, 1]. A constant boundary color is used for U,V values that fall outside this range.

### WRAP

    public static final int WRAP

  Repeats the texture by wrapping texture coordinates that are outside the range [0,1]. Only the fractional portion of the texture coordinates is used; the integer portion is discarded.

### BASE_LEVEL

    public static final int BASE_LEVEL

  Indicates that Texture object only has one level. If multiple levels are needed, they will be implicitely computed.

### MULTI_LEVEL_MIPMAP

    public static final int MULTI_LEVEL_MIPMAP

  Indicates that this Texture object has multiple images- one for each mipmap level(i.e. log2(max(Width,Height)) + 1 seperate images.

### INTENSITY

    public static final int INTENSITY

  Specifies Texture contains only Intensity values.

### LUMINANCE

    public static final int LUMINANCE

  Specifies Texture contains only luminance values.

### ALPHA

    public static final int ALPHA

  Specifies Texture contains only Alpha values.

### LUMINANCE_ALPHA

    public static final int LUMINANCE_ALPHA

  Specifies Texture contains Luminance and Alpha values.

### RGB

    public static final int RGB

  Specifies Texture contains Red, Green and Blue color values.

### RGBA

    public static final int RGBA

  Specifies Texture contains Red, Green, Blue color values and Alpha value.

Constructor Detail

### Texture

    public Texture()

  Constructs a Texture object with default parameters. The default values are as follows:
  enable flag : true
  width : 0
  height : 0
  mipmap mode : BASE_LEVEL
  format : RGB
  boundary mode S : WRAP
  boundary mode T : WRAP
  min filter : BASE_LEVEL_POINT
  mag filter : BASE_LEVEL_POINT
  boundary color : black (0,0,0,0)
  image : null

  Note that the default constructor creates a texture object with a width and height of 0 and is, therefore, not useful.

### Texture

    public Texture(int mipmapMode,
                   int format,
                   int width,
                   int height)

  Constructs an empty Texture object with specified mipmapMode format, width and height. Defaults are used for all other parameters. Image at level 0 must be set by the application using 'setImage' method. If mipmapMode is set to MULTI_LEVEL_MIPMAP, images for ALL levels must be set.
  Parameters:
    `mipmapMode` - type of mipmap for this Texture: One of BASE_LEVEL, MULTI_LEVEL_MIPMAP.
    `format` - data format of Textures saved in this object. One of INTENSITY, LUMINANCE, ALPHA, LUMINANCE_ALPHA, RGB, RGBA.
    `width` - width of image at level 0. Must be power of 2.
    `height` - height of image at level 0. Must be power of 2.
  Throws:
    java.lang.IllegalArgumentException - if width or height are NOT power of 2 OR invalid format/mipmapMode is specified.

Method Detail

### setBoundaryModeS

    public final void setBoundaryModeS(int boundaryModeS)

  Sets the boundary mode for the S coordinate in this texture object.
  Parameters:
    `boundaryModeS` - the boundary mode for the S coordinate, one of: CLAMP or WRAP.
  Throws:
    RestrictedAccessException - if the method is called when this object is part of live or compiled scene graph.

### getBoundaryModeS

    public final int getBoundaryModeS()

  Retrieves the boundary mode for the S coordinate.
  Returns:
    the current boundary mode for the S coordinate.
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### setBoundaryModeT

    public final void setBoundaryModeT(int boundaryModeT)

  Sets the boundary mode for the T coordinate in this texture object.
  Parameters:
    `boundaryModeT` - the boundary mode for the T coordinate, one of: CLAMP or WRAP.
  Throws:
    RestrictedAccessException - if the method is called when this object is part of live or compiled scene graph.

### getBoundaryModeT

    public final int getBoundaryModeT()

  Retrieves the boundary mode for the T coordinate.
  Returns:
    the current boundary mode for the T coordinate.
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### setMinFilter

    public final void setMinFilter(int minFilter)

  Sets the minification filter function. This function is used when the pixel being rendered maps to an area greater than one texel.
  Parameters:
    `minFilter` - the minification filter, one of: FASTEST, NICEST, BASE_LEVEL_POINT, BASE_LEVEL_LINEAR, MULTI_LEVEL_POINT, MULTI_LEVEL_LINEAR.
  Throws:
    RestrictedAccessException - if the method is called when this object is part of live or compiled scene graph.

### getMinFilter

    public final int getMinFilter()

  Retrieves the minification filter.
  Returns:
    the current minification filter function.
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### setMagFilter

    public final void setMagFilter(int magFilter)

  Sets the magnification filter function. This function is used when the pixel being rendered maps to an area less than or equal to one texel.
  Parameters:
    `magFilter` - the magnification filter, one of: FASTEST, NICEST, BASE_LEVEL_POINT, or BASE_LEVEL_LINEAR.
  Throws:
    RestrictedAccessException - if the method is called when this object is part of live or compiled scene graph.

### getMagFilter

    public final int getMagFilter()

  Retrieves the magnification filter.
  Returns:
    the current magnification filter function.
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### setImage

    public final void setImage(int level,
                               ImageComponent image)

  Sets a specified mipmap level.
  Parameters:
    `level` - mipmap level to set: 0 is the base level
    `image` - pixel array object containing the texture image
  Throws:
    RestrictedAccessException - if the method is called when this object is part of live or compiled scene graph.
    java.lang.IllegalArgumentException - if an ImageComponent3D is used in a Texture2D or ImageComponent2D in Texture3D power of 2 OR invalid format/mipmapMode is specified.

### getImage

    public final ImageComponent getImage(int level)

  Gets a specified mipmap level.
  Parameters:
    `level` - mipmap level to get: 0 is the base level
  Returns:
    the pixel array object containing the texture image
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### setMipMapMode

    public final void setMipMapMode(int mipmapMode)

  Sets mipmap mode for texture mapping for this texture object.
  Parameters:
    `mipMapMode` - the new mipmap mode for this object. One of: BASE_LEVEL or MULTI_LEVEL_MIPMAP.
  Throws:
    RestrictedAccessException - if the method is called when this object is part of live or compiled scene graph.

### getMipMapMode

    public final int getMipMapMode()

  Retrieves current mipmap mode.
  Returns:
    current mipmap mode of this texture object.
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### setEnable

    public final void setEnable(boolean state)

  Enables or disables texture mapping for this appearance component object.
  Parameters:
    `state` - true or false to enable or disable texture mapping
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### getEnable

    public final boolean getEnable()

  Retrieves the state of the texture enable flag.
  Returns:
    true if texture mapping is enabled, false if texture mapping is disabled
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### setBoundaryColor

    public final void setBoundaryColor(Color4f boundaryColor)

  Sets the texture boundary color for this texture object. The texture boundary color is used when boundaryModeS or boundaryModeT is set to CLAMP.
  Parameters:
    `boundaryColor` - the new texture boundary color.
  Throws:
    RestrictedAccessException - if the method is called when this object is part of live or compiled scene graph.

### setBoundaryColor

    public final void setBoundaryColor(float r,
                                       float g,
                                       float b,
                                       float a)

  Sets the texture boundary color for this texture object. The texture boundary color is used when boundaryModeS or boundaryModeT is set to CLAMP.
  Parameters:
    `r` - the red component of the color.
    `g` - the green component of the color.
    `b` - the blue component of the color.
    `a` - the alpha component of the color.
  Throws:
    RestrictedAccessException - if the method is called when this object is part of live or compiled scene graph.

### getBoundaryColor

    public final void getBoundaryColor(Color4f boundaryColor)

  Retrieves the texture boundary color for this texture object.
  Parameters:
    `boundaryColor` - the vector that will receive the current texture boundary color.
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD